%% Solve Gray-Scott by PDE2, hannes.uecker@uni-oldenburg.de, 2011/04  
npde=2; nx=100; ny=100; u=zeros(npde,nx,ny); lx=150; ly=lx; t=0;
x=linspace(0,lx,nx);y=linspace(0,ly,ny); [X,Y]=meshgrid(x,y); 
X=X'; Y=Y'; % transpose, since u=u(nx,ny) 
xa=-0.001*((X-lx/2).^2+(Y-ly/2).^2); 
u(1,:,:)=1-0.5*exp(xa);
u(2,:,:)=0.3*exp(0.01*xa.*(X+lx/2));
u1=squeeze(u(1,:,:)); u2=squeeze(u(2,:,:)); 
figure(1);clf; pcolor(X,Y,u1);colorbar;grid off; colormap gray; 
shading interp; tit=title(['u,  t= ',num2str(t)]); anno1(tit,lx);
set(figure(1),'Position', [1000 400 370 300]);
figure(2);clf; pcolor(X,Y,u2);colorbar;grid off; colormap gray; 
shading interp; tit=title(['v,  t= ',num2str(t)]); anno1(tit,lx);
set(figure(2),'Position', [1000 20 370 300]);
%%
para=zeros(1,100); para(1:4)=[1, 0.5, 0.038, 0.06]; npara=4;
t0=0; t1=0.1; epsi=0.00000001; h=0.00001; mf=10; index=1; 
tic;[u, index, h]=gsstep(t0,t1,h,epsi,mf,index,x,y,u,para,npara); toc
u1=squeeze(u(1,:,:)); u2=squeeze(u(2,:,:)); h
figure(1);clf;pcolor(X,Y,u1);colorbar; shading interp; 
grid off; tit=title(['u,  t= ',num2str(t1)]); anno1(tit,lx); 
figure(2);clf;pcolor(X,Y,u2);colorbar; shading interp; 
grid off; tit=title(['u,  t= ',num2str(t1)]); anno1(tit,ly); 
%%
dt=1;dt=asknu('dt (0 for end)',dt); 
while(dt>0)
    t0=t1; t1=t0+dt; 
    tic; [u, index, h]=gsstep(t0,t1,h,epsi,mf,index,x,y,u,para,npara); toc
    u1=squeeze(u(1,:,:)); u2=squeeze(u(2,:,:)); h
    figure(1);clf;pcolor(X,Y,u1);colorbar; shading interp; 
    grid off; tit=title(['u,  t= ',num2str(t1)]); anno1(tit,lx); 
    figure(2);clf;pcolor(X,Y,u2);colorbar; shading interp; 
    grid off; tit=title(['u,  t= ',num2str(t1)]); anno1(tit,ly); 
    dt=asknu('dt (0 for end)',dt);
end 